GDAL

- Main Page
- Related Pages
- Classes
- Files
- Download
- Issue Tracker

- Class List
- Class Hierarchy
- Class Members

Public Member Functions | Static Protected Member Functions | List of all members
OGRLinearRing Class Reference

Concrete representation of a closed ring. More...

`#include <ogr_geometry.h>`

Inheritance diagram for OGRLinearRing:

## Public Member Functions
| OGRLinearRing ()
| Constructor.
| OGRLinearRing (const OGRLinearRing &other)
| Copy constructor. More...
| OGRLinearRing (OGRLinearRing *)
| Constructor. More...
OGRLinearRing & | operator= (const OGRLinearRing &other)
| Assignment operator. More...
virtual const char * | getGeometryName () const override
| Fetch WKT name for geometry type. More...
virtual OGRGeometry * | clone () const override
| Make a copy of this object. More...
virtual int | isClockwise () const
| Returns TRUE if the ring has clockwise winding (or less than 2 points) More...
virtual void | reverseWindingOrder ()
| Reverse order of points.
virtual void | closeRings () override
| Force rings to be closed. More...
OGRBoolean | isPointInRing (const OGRPoint *pt, int bTestEnvelope=TRUE) const
| Returns whether the point is inside the ring. More...
OGRBoolean | isPointOnRingBoundary (const OGRPoint *pt, int bTestEnvelope=TRUE) const
| Returns whether the point is on the ring boundary. More...
virtual OGRErr | transform (OGRCoordinateTransformation *poCT) override
| Apply arbitrary coordinate transformation to geometry. More...
OGRLineString * | toUpperClass ()
| Return pointer of this in upper class.
const OGRLineString * | toUpperClass () const
| Return pointer of this in upper class.
virtual void | accept (IOGRGeometryVisitor *visitor) override
| Accept a visitor. More...
virtual void | accept (IOGRConstGeometryVisitor *visitor) const override
| Accept a visitor. More...
virtual int | WkbSize () const override
| Returns size of related binary representation. More...
virtual OGRErr | importFromWkb (const unsigned char *, int, OGRwkbVariant, int &nBytesConsumedOut) override
| Assign geometry from well known binary data. More...
virtual OGRErr | exportToWkb (OGRwkbByteOrder, unsigned char *, OGRwkbVariant=wkbVariantOldOgc) const override
| Convert a geometry into well known binary format. More...
Public Member Functions inherited from OGRLineString
| OGRLineString ()
| Create an empty line string.
| OGRLineString (const OGRLineString &other)
| Copy constructor. More...
OGRLineString & | operator= (const OGRLineString &other)
| Assignment operator. More...
virtual OGRLineString * | CurveToLine (double dfMaxAngleStepSizeDegrees=0, const char *const *papszOptions=nullptr) const override
| Return a linestring from a curve geometry. More...
virtual OGRGeometry * | getCurveGeometry (const char *const *papszOptions=nullptr) const override
| Return curve version of this geometry. More...
virtual double | get_Area () const override
| Get the area of the (closed) curve. More...
virtual OGRwkbGeometryType | getGeometryType () const override
| Fetch geometry type. More...
OGRSimpleCurve * | toUpperClass ()
| Return pointer of this in upper class.
const OGRSimpleCurve * | toUpperClass () const
| Return pointer of this in upper class.
Public Member Functions inherited from OGRSimpleCurve
OGRSimpleCurve & | operator= (const OGRSimpleCurve &other)
| Assignment operator. More...
Iterator | begin ()
| Return begin of point iterator. More...
Iterator | end ()
| Return end of point iterator. More...
ConstIterator | begin () const
| Return begin of point iterator. More...
ConstIterator | end () const
| Return end of point iterator. More...
OGRErr | importFromWkt (const char **) override
| deprecated
virtual OGRErr | exportToWkt (char **ppszDstText, OGRwkbVariant=wkbVariantOldOgc) const override
| Convert a geometry into well known text format. More...
virtual void | empty () override
| Clear geometry information. More...
virtual void | getEnvelope (OGREnvelope *psEnvelope) const override
| Computes and returns the bounding envelope for this geometry in the passed psEnvelope structure. More...
virtual void | getEnvelope (OGREnvelope3D *psEnvelope) const override
| Computes and returns the bounding envelope (3D) for this geometry in the passed psEnvelope structure. More...
virtual OGRBoolean | IsEmpty () const override
| Returns TRUE (non-zero) if the object has no points. More...
virtual double | get_Length () const override
| Returns the length of the curve. More...
virtual void | StartPoint (OGRPoint *) const override
| Return the curve start point. More...
virtual void | EndPoint (OGRPoint *) const override
| Return the curve end point. More...
virtual void | Value (double, OGRPoint *) const override
| Fetch point at given distance along curve. More...
virtual double | Project (const OGRPoint *) const
| Project point on linestring. More...
virtual OGRLineString * | getSubLine (double, double, int) const
| Get the portion of linestring. More...
virtual int | getNumPoints () const override
| Fetch vertex count. More...
void | getPoint (int, OGRPoint *) const
| Fetch a point in line string. More...
double | getX (int i) const
| Get X at vertex. More...
double | getY (int i) const
| Get Y at vertex. More...
double | getZ (int i) const
| Get Z at vertex. More...
double | getM (int i) const
| Get measure at vertex. More...
virtual OGRBoolean | Equals (const OGRGeometry *) const override
| Returns TRUE if two geometries are equivalent. More...
virtual void | setCoordinateDimension (int nDimension) override
| Set the coordinate dimension. More...
virtual void | set3D (OGRBoolean bIs3D) override
| Add or remove the Z coordinate dimension. More...
virtual void | setMeasured (OGRBoolean bIsMeasured) override
| Add or remove the M coordinate dimension. More...
void | setNumPoints (int nNewPointCount, int bZeroizeNewContent=TRUE)
| Set number of points in geometry. More...
void | setPoint (int, OGRPoint *)
| Set the location of a vertex in line string. More...
void | setPoint (int, double, double)
| Set the location of a vertex in line string. More...
void | setZ (int, double)
| Set the Z of a vertex in line string. More...
void | setM (int, double)
| Set the M of a vertex in line string. More...
void | setPoint (int, double, double, double)
| Set the location of a vertex in line string. More...
void | setPointM (int, double, double, double)
| Set the location of a vertex in line string. More...
void | setPoint (int, double, double, double, double)
| Set the location of a vertex in line string. More...
void | setPoints (int, const OGRRawPoint *, const double *=nullptr)
| Assign all points in a line string. More...
void | setPointsM (int, const OGRRawPoint *, const double *)
| Assign all points in a line string. More...
void | setPoints (int, const OGRRawPoint *, const double *, const double *)
| Assign all points in a line string. More...
void | setPoints (int, const double *padfX, const double *padfY, const double *padfZIn=nullptr)
| Assign all points in a line string. More...
void | setPointsM (int, const double *padfX, const double *padfY, const double *padfMIn=nullptr)
| Assign all points in a line string. More...
void | setPoints (int, const double *padfX, const double *padfY, const double *padfZIn, const double *padfMIn)
| Assign all points in a line string. More...
void | addPoint (const OGRPoint *)
| Add a point to a line string. More...
void | addPoint (double, double)
| Add a point to a line string. More...
void | addPoint (double, double, double)
| Add a point to a line string. More...
void | addPointM (double, double, double)
| Add a point to a line string. More...
void | addPoint (double, double, double, double)
| Add a point to a line string. More...
void | getPoints (OGRRawPoint *, double *=nullptr) const
| Returns all points of line string. More...
void | getPoints (void *pabyX, int nXStride, void *pabyY, int nYStride, void *pabyZ=nullptr, int nZStride=0) const
| Returns all points of line string. More...
void | getPoints (void *pabyX, int nXStride, void *pabyY, int nYStride, void *pabyZ, int nZStride, void *pabyM, int nMStride) const
| Returns all points of line string. More...
void | addSubLineString (const OGRLineString *, int nStartVertex=0, int nEndVertex=-1)
| Add a segment of another linestring to this one. More...
void | reversePoints (void)
| Reverse point order. More...
virtual OGRPointIterator * | getPointIterator () const override
| Returns a point iterator over the curve. More...
virtual void | flattenTo2D () override
| Convert geometry to strictly 2D. More...
virtual void | segmentize (double dfMaxLength) override
| Modify the geometry such it has no segment longer then the given distance. More...
virtual void | swapXY () override
| Swap x and y coordinates. More...
Public Member Functions inherited from OGRCurve
ConstIterator | begin () const
| Return begin of a point iterator. More...
ConstIterator | end () const
| Return end of a point iterator. More...
virtual int | get_IsClosed () const
| Return TRUE if curve is closed. More...
virtual int | getDimension () const override
| Get the dimension of this object. More...
virtual OGRBoolean | IsConvex () const
| Returns if a (closed) curve forms a convex shape. More...
OGRSimpleCurve * | toSimpleCurve ()
| Down-cast to OGRSimpleCurve*. More...
const OGRSimpleCurve * | toSimpleCurve () const
| Down-cast to OGRSimpleCurve*. More...
Public Member Functions inherited from OGRGeometry
| OGRGeometry (const OGRGeometry &other)
| Copy constructor. More...
OGRGeometry & | operator= (const OGRGeometry &other)
| Assignment operator. More...
bool | operator== (const OGRGeometry &other) const
| Returns if two geometries are equal. More...
bool | operator!= (const OGRGeometry &other) const
| Returns if two geometries are different. More...
virtual int | getCoordinateDimension () const
| Get the dimension of the coordinates in this object. More...
int | CoordinateDimension () const
| Get the dimension of the coordinates in this object. More...
virtual OGRBoolean | IsValid () const
| Test if the geometry is valid. More...
virtual OGRBoolean | IsSimple () const
| Test if the geometry is simple. More...
OGRBoolean | Is3D () const
OGRBoolean | IsMeasured () const
virtual OGRBoolean | IsRing () const
| Test if the geometry is a ring. More...
OGRErr | importFromWkb (const GByte *, int=-1, OGRwkbVariant=wkbVariantOldOgc)
| Assign geometry from well known binary data. More...
OGRErr | importFromWkt (char **ppszInput) CPL_WARN_DEPRECATED("Use importFromWkt( const char**) instead")
| Deprecated. More...
OGRwkbGeometryType | getIsoGeometryType () const
| Get the geometry type that conforms with ISO SQL/MM Part3. More...
virtual void | dumpReadable (FILE *, const char *=nullptr, char **papszOptions=nullptr) const
| Dump geometry in well known text format to indicated output file. More...
virtual char * | exportToGML (const char *const *papszOptions=nullptr) const
| Convert a geometry into GML format. More...
virtual char * | exportToKML () const
| Convert a geometry into KML format. More...
virtual char * | exportToJson () const
| Convert a geometry into GeoJSON format. More...
virtual GEOSGeom | exportToGEOS (GEOSContextHandle_t hGEOSCtxt) const CPL_WARN_UNUSED_RESULT
| Returns a GEOSGeom object corresponding to the geometry. More...
virtual OGRBoolean | hasCurveGeometry (int bLookForNonLinear=FALSE) const
| Returns if this geometry is or has curve geometry. More...
virtual OGRGeometry * | getLinearGeometry (double dfMaxAngleStepSizeDegrees=0, const char *const *papszOptions=nullptr) const CPL_WARN_UNUSED_RESULT
| Return, possibly approximate, non-curve version of this geometry. More...
virtual void | assignSpatialReference (OGRSpatialReference *poSR)
| Assign spatial reference to this object. More...
OGRSpatialReference * | getSpatialReference (void) const
| Returns spatial reference system for object. More...
OGRErr | transformTo (OGRSpatialReference *poSR)
| Transform geometry to new spatial reference system. More...
virtual OGRBoolean | Intersects (const OGRGeometry *) const
| Do these features intersect? More...
virtual OGRBoolean | Disjoint (const OGRGeometry *) const
| Test for disjointness. More...
virtual OGRBoolean | Touches (const OGRGeometry *) const
| Test for touching. More...
virtual OGRBoolean | Crosses (const OGRGeometry *) const
| Test for crossing. More...
virtual OGRBoolean | Within (const OGRGeometry *) const
| Test for containment. More...
virtual OGRBoolean | Contains (const OGRGeometry *) const
| Test for containment. More...
virtual OGRBoolean | Overlaps (const OGRGeometry *) const
| Test for overlap. More...
virtual OGRGeometry * | Boundary () const CPL_WARN_UNUSED_RESULT
| Compute boundary. More...
virtual double | Distance (const OGRGeometry *) const
| Compute distance between two geometries. More...
virtual OGRGeometry * | ConvexHull () const CPL_WARN_UNUSED_RESULT
| Compute convex hull. More...
virtual OGRGeometry * | Buffer (double dfDist, int nQuadSegs=30) const CPL_WARN_UNUSED_RESULT
| Compute buffer of geometry. More...
virtual OGRGeometry * | Intersection (const OGRGeometry *) const CPL_WARN_UNUSED_RESULT
| Compute intersection. More...
virtual OGRGeometry * | Union (const OGRGeometry *) const CPL_WARN_UNUSED_RESULT
| Compute union. More...
virtual OGRGeometry * | UnionCascaded () const CPL_WARN_UNUSED_RESULT
| Compute union using cascading. More...
virtual OGRGeometry * | Difference (const OGRGeometry *) const CPL_WARN_UNUSED_RESULT
| Compute difference. More...
virtual OGRGeometry * | SymDifference (const OGRGeometry *) const CPL_WARN_UNUSED_RESULT
| Compute symmetric difference. More...
virtual OGRErr | Centroid (OGRPoint *poPoint) const
| Compute the geometry centroid. More...
virtual OGRGeometry * | Simplify (double dTolerance) const CPL_WARN_UNUSED_RESULT
| Simplify the geometry. More...
OGRGeometry * | SimplifyPreserveTopology (double dTolerance) const CPL_WARN_UNUSED_RESULT
| Simplify the geometry while preserving topology. More...
virtual OGRGeometry * | DelaunayTriangulation (double dfTolerance, int bOnlyEdges) const CPL_WARN_UNUSED_RESULT
| Return a Delaunay triangulation of the vertices of the geometry. More...
virtual OGRGeometry * | Polygonize () const CPL_WARN_UNUSED_RESULT
| Polygonizes a set of sparse edges. More...
virtual double | Distance3D (const OGRGeometry *poOtherGeom) const
| Returns the 3D distance between two geometries. More...
OGRPoint * | toPoint ()
| Down-cast to OGRPoint*. More...
const OGRPoint * | toPoint () const
| Down-cast to OGRPoint*. More...
OGRCurve * | toCurve ()
| Down-cast to OGRCurve*. More...
const OGRCurve * | toCurve () const
| Down-cast to OGRCurve*. More...
OGRSimpleCurve * | toSimpleCurve ()
| Down-cast to OGRSimpleCurve*. More...
const OGRSimpleCurve * | toSimpleCurve () const
| Down-cast to OGRSimpleCurve*. More...
OGRLineString * | toLineString ()
| Down-cast to OGRLineString*. More...
const OGRLineString * | toLineString () const
| Down-cast to OGRLineString*. More...
OGRLinearRing * | toLinearRing ()
| Down-cast to OGRLinearRing*. More...
const OGRLinearRing * | toLinearRing () const
| Down-cast to OGRLinearRing*. More...
OGRCircularString * | toCircularString ()
| Down-cast to OGRCircularString*. More...
const OGRCircularString * | toCircularString () const
| Down-cast to OGRCircularString*. More...
OGRCompoundCurve * | toCompoundCurve ()
| Down-cast to OGRCompoundCurve*. More...
const OGRCompoundCurve * | toCompoundCurve () const
| Down-cast to OGRCompoundCurve*. More...
OGRSurface * | toSurface ()
| Down-cast to OGRSurface*. More...
const OGRSurface * | toSurface () const
| Down-cast to OGRSurface*. More...
OGRPolygon * | toPolygon ()
| Down-cast to OGRPolygon*. More...
const OGRPolygon * | toPolygon () const
| Down-cast to OGRPolygon*. More...
OGRTriangle * | toTriangle ()
| Down-cast to OGRTriangle*. More...
const OGRTriangle * | toTriangle () const
| Down-cast to OGRTriangle*. More...
OGRCurvePolygon * | toCurvePolygon ()
| Down-cast to OGRCurvePolygon*. More...
const OGRCurvePolygon * | toCurvePolygon () const
| Down-cast to OGRCurvePolygon*. More...
OGRGeometryCollection * | toGeometryCollection ()
| Down-cast to OGRGeometryCollection*. More...
const OGRGeometryCollection * | toGeometryCollection () const
| Down-cast to OGRGeometryCollection*. More...
OGRMultiPoint * | toMultiPoint ()
| Down-cast to OGRMultiPoint*. More...
const OGRMultiPoint * | toMultiPoint () const
| Down-cast to OGRMultiPoint*. More...
OGRMultiLineString * | toMultiLineString ()
| Down-cast to OGRMultiLineString*. More...
const OGRMultiLineString * | toMultiLineString () const
| Down-cast to OGRMultiLineString*. More...
OGRMultiPolygon * | toMultiPolygon ()
| Down-cast to OGRMultiPolygon*. More...
const OGRMultiPolygon * | toMultiPolygon () const
| Down-cast to OGRMultiPolygon*. More...
OGRMultiCurve * | toMultiCurve ()
| Down-cast to OGRMultiCurve*. More...
const OGRMultiCurve * | toMultiCurve () const
| Down-cast to OGRMultiCurve*. More...
OGRMultiSurface * | toMultiSurface ()
| Down-cast to OGRMultiSurface*. More...
const OGRMultiSurface * | toMultiSurface () const
| Down-cast to OGRMultiSurface*. More...
OGRPolyhedralSurface * | toPolyhedralSurface ()
| Down-cast to OGRPolyhedralSurface*. More...
const OGRPolyhedralSurface * | toPolyhedralSurface () const
| Down-cast to OGRPolyhedralSurface*. More...
OGRTriangulatedSurface * | toTriangulatedSurface ()
| Down-cast to OGRTriangulatedSurface*. More...
const OGRTriangulatedSurface * | toTriangulatedSurface () const
| Down-cast to OGRTriangulatedSurface*. More...

## Static Protected Member Functions
static OGRLineString * | CastToLineString (OGRLinearRing *poLR)
| Cast to line string. More...
Static Protected Member Functions inherited from OGRLineString
static OGRLinearRing * | CastToLinearRing (OGRLineString *poLS)
| Cast to linear ring. More...

## Additional Inherited Members
Public Types inherited from OGRSimpleCurve
typedef OGRPoint | ChildType
| Type of child elements. More...
Public Types inherited from OGRCurve
typedef OGRPoint | ChildType
| Type of child elements. More...
Static Public Member Functions inherited from OGRCurve
static OGRCompoundCurve * | CastToCompoundCurve (OGRCurve *puCurve)
| Cast to compound curve. More...
static OGRLineString * | CastToLineString (OGRCurve *poCurve)
| Cast to linestring. More...
static OGRLinearRing * | CastToLinearRing (OGRCurve *poCurve)
| Cast to linear ring. More...
Static Public Member Functions inherited from OGRGeometry
static GEOSContextHandle_t | createGEOSContext ()
| Create a new GEOS context. More...
static void | freeGEOSContext (GEOSContextHandle_t hGEOSCtxt)
| Destroy a GEOS context. More...
static OGRGeometryH | ToHandle (OGRGeometry *poGeom)
| Convert a OGRGeometry* to a OGRGeometryH. More...
static OGRGeometry * | FromHandle (OGRGeometryH hGeom)
| Convert a OGRGeometryH to a OGRGeometry*. More...
Protected Member Functions inherited from OGRSimpleCurve
virtual double | get_LinearArea () const
| Compute area of ring / closed linestring. More...
| OGRSimpleCurve ()
| Constructor.
| OGRSimpleCurve (const OGRSimpleCurve &other)
| Copy constructor. More...
Protected Member Functions inherited from OGRCurve
virtual int | ContainsPoint (const OGRPoint *p) const
| Returns if a point is contained in a (closed) curve. More...
virtual int | IntersectsPoint (const OGRPoint *p) const
| Returns if a point intersects a (closed) curve. More...
virtual double | get_AreaOfCurveSegments () const =0
| Get the area of the purely curve portions of a (closed) curve. More...

## Detailed Description

Concrete representation of a closed ring.

This class is functionally equivalent to an OGRLineString, but has a separate identity to maintain alignment with the OpenGIS simple feature data model. It exists to serve as a component of an OGRPolygon.

The OGRLinearRing has no corresponding free standing well known binary representation, so importFromWkb() and exportToWkb() will not actually work. There is a non-standard GDAL WKT representation though.

Because OGRLinearRing is not a "proper" free standing simple features object, it cannot be directly used on a feature via SetGeometry(), and cannot generally be used with GEOS for operations like Intersects(). Instead the polygon should be used, or the OGRLinearRing should be converted to an OGRLineString for such operations.

Note: this class exists in SFSQL 1.2, but not in ISO SQL/MM Part 3.

## Constructor & Destructor Documentation

OGRLinearRing::OGRLinearRing | ( | const OGRLinearRing & | other | ) |
| default

Copy constructor.

Note: before GDAL 2.1, only the default implementation of the constructor existed, which could be unsafe to use.

Since
  GDAL 2.1

OGRLinearRing::OGRLinearRing | ( | OGRLinearRing * | poSrcRing | ) |
| explicit

Constructor.

Parameters

  poSrcRing | source ring.

## Member Function Documentation

virtual void OGRLinearRing::accept | ( | IOGRGeometryVisitor * | visitor | ) |
| inline override virtual

Accept a visitor.

Reimplemented from OGRLineString.

virtual void OGRLinearRing::accept | ( | IOGRConstGeometryVisitor * | visitor | ) | const
| inline override virtual

Accept a visitor.

Reimplemented from OGRLineString.

OGRLineString * OGRLinearRing::CastToLineString | ( | OGRLinearRing * | poLR | ) |
| static protected

Cast to line string.

The passed in geometry is consumed and a new one returned .

Parameters

  poLR | the input geometry - ownership is passed to the method.

Returns
  new geometry.

OGRGeometry * OGRLinearRing::clone | ( |  | ) | const
| override virtual

Make a copy of this object.

This method relates to the SFCOM IGeometry::clone() method.

This method is the same as the C function OGR_G_Clone().

Returns
  a new object instance with the same geometry, and spatial reference system as the original.

Reimplemented from OGRSimpleCurve.

void OGRLinearRing::closeRings | ( |  | ) |
| override virtual

Force rings to be closed.

If this geometry, or any contained geometries has polygon rings that are not closed, they will be closed by adding the starting point at the end.

Reimplemented from OGRGeometry.

OGRErr OGRLinearRing::exportToWkb | ( | OGRwkbByteOrder | eByteOrder,
|  | unsigned char * | pabyData,
|  | OGRwkbVariant | eWkbVariant = `wkbVariantOldOgc`
| ) |  | const
| override virtual

Convert a geometry into well known binary format.

This method relates to the SFCOM IWks::ExportToWKB() method.

This method is the same as the C function OGR_G_ExportToWkb() or OGR_G_ExportToIsoWkb(), depending on the value of eWkbVariant.

Parameters

  eByteOrder | One of wkbXDR or wkbNDR indicating MSB or LSB byte order respectively.
  pabyData | a buffer into which the binary representation is written. This buffer must be at least OGRGeometry::WkbSize() byte in size.
  eWkbVariant | What standard to use when exporting geometries with three dimensions (or more). The default wkbVariantOldOgc is the historical OGR variant. wkbVariantIso is the variant defined in ISO SQL/MM and adopted by OGC for SFSQL 1.2.

Returns
  Currently OGRERR_NONE is always returned.

Reimplemented from OGRSimpleCurve.

const char * OGRLinearRing::getGeometryName | ( |  | ) | const
| override virtual

Fetch WKT name for geometry type.

There is no SFCOM analog to this method.

This method is the same as the C function OGR_G_GetGeometryName().

Returns
  name used for this geometry type in well known text format. The returned pointer is to a static internal string and should not be modified or freed.

Reimplemented from OGRLineString.

OGRErr OGRLinearRing::importFromWkb | ( | const unsigned char * | pabyData,
|  | int | nSize,
|  | OGRwkbVariant | eWkbVariant,
|  | int & | nBytesConsumedOut
| ) |  |
| override virtual

Assign geometry from well known binary data.

The object must have already been instantiated as the correct derived type of geometry object to match the binaries type. This method is used by the OGRGeometryFactory class, but not normally called by application code.

This method relates to the SFCOM IWks::ImportFromWKB() method.

This method is the same as the C function OGR_G_ImportFromWkb().

Parameters

  pabyData | the binary input data.
  nSize | the size of pabyData in bytes, or -1 if not known.
  eWkbVariant | if wkbVariantPostGIS1, special interpretation is done for curve geometries code
  nBytesConsumedOut | output parameter. Number of bytes consumed.

Returns
  OGRERR_NONE if all goes well, otherwise any of OGRERR_NOT_ENOUGH_DATA, OGRERR_UNSUPPORTED_GEOMETRY_TYPE, or OGRERR_CORRUPT_DATA may be returned.

Since
  GDAL 2.3

Reimplemented from OGRSimpleCurve.

int OGRLinearRing::isClockwise | ( |  | ) | const
| virtual

Returns TRUE if the ring has clockwise winding (or less than 2 points)

Returns
  TRUE if clockwise otherwise FALSE.

OGRBoolean OGRLinearRing::isPointInRing | ( | const OGRPoint * | poPoint,
|  | int | bTestEnvelope = `TRUE`
| ) |  | const

Returns whether the point is inside the ring.

Parameters

  poPoint | point
  bTestEnvelope | set to TRUE if the presence of the point inside the ring envelope must be checked first.

Returns
  TRUE or FALSE.

OGRBoolean OGRLinearRing::isPointOnRingBoundary | ( | const OGRPoint * | poPoint,
|  | int | bTestEnvelope = `TRUE`
| ) |  | const

Returns whether the point is on the ring boundary.

Parameters

  poPoint | point
  bTestEnvelope | set to TRUE if the presence of the point inside the ring envelope must be checked first.

Returns
  TRUE or FALSE.

OGRLinearRing & OGRLinearRing::operator= | ( | const OGRLinearRing & | other | ) |

Assignment operator.

Note: before GDAL 2.1, only the default implementation of the operator existed, which could be unsafe to use.

Since
  GDAL 2.1

OGRErr OGRLinearRing::transform | ( | OGRCoordinateTransformation * | poCT | ) |
| override virtual

Apply arbitrary coordinate transformation to geometry.

This method will transform the coordinates of a geometry from their current spatial reference system to a new target spatial reference system. Normally this means reprojecting the vectors, but it could include datum shifts, and changes of units.

Note that this method does not require that the geometry already have a spatial reference system. It will be assumed that they can be treated as having the source spatial reference system of the OGRCoordinateTransformation object, and the actual SRS of the geometry will be ignored. On successful completion the output OGRSpatialReference of the OGRCoordinateTransformation will be assigned to the geometry.

This method is the same as the C function OGR_G_Transform().

Parameters

  poCT | the transformation to apply.

Returns
  OGRERR_NONE on success or an error code.

Reimplemented from OGRSimpleCurve.

int OGRLinearRing::WkbSize | ( |  | ) | const
| override virtual

Returns size of related binary representation.

This method returns the exact number of bytes required to hold the well known binary representation of this geometry object. Its computation may be slightly expensive for complex geometries.

This method relates to the SFCOM IWks::WkbSize() method.

This method is the same as the C function OGR_G_WkbSize().

Returns
  size of binary representation in bytes.

Reimplemented from OGRSimpleCurve.

The documentation for this class was generated from the following files:

- ogr_geometry.h
- ogrlinearring.cpp

Generated for GDAL by 1.8.8.